"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const ts = __importStar(require("typescript"));
function createTypeScriptPnpExtension() {
    // eslint-disable-next-line @typescript-eslint/no-var-requires,node/no-missing-require
    const { resolveModuleName } = require('ts-pnp');
    function extendModuleResolutionHost(host, parsedCommendLine) {
        const compilerOptions = parsedCommendLine ? parsedCommendLine.options : undefined;
        function resolveModuleNames(moduleNames, containingFile) {
            return moduleNames.map((moduleName) => {
                return resolveModuleName(moduleName, containingFile, compilerOptions, host, ts.resolveModuleName).resolvedModule;
            });
        }
        function resolveTypeReferenceDirectives(typeDirectiveNames, containingFile) {
            return typeDirectiveNames.map((typeDirectiveName) => {
                return resolveModuleName(typeDirectiveName, containingFile, compilerOptions, host, ts.resolveTypeReferenceDirective).resolvedTypeReferenceDirective;
            });
        }
        return Object.assign(Object.assign({}, host), { resolveModuleNames,
            resolveTypeReferenceDirectives });
    }
    return {
        extendWatchSolutionBuilderHost: extendModuleResolutionHost,
        extendWatchCompilerHost: extendModuleResolutionHost,
        extendCompilerHost: extendModuleResolutionHost,
    };
}
exports.createTypeScriptPnpExtension = createTypeScriptPnpExtension;
